<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #3                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Database
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */
class database
{

    function dbconnect()
    {
        global $config, $main_db_link, $database;
        if ( $main_db_link = @mysqli_connect( $config[ 'DB_HOSTNAME' ], $config[ 'DB_USERNAME' ], $config[ 'DB_PASSWORD' ], $config[ 'DB_DATABASE' ] ) )
        {
            if( !isset( $config[ 'DB_COLLATION' ] ) )
            {
                $config[ 'DB_COLLATION' ] = "Default";
            }
            if( $config[ 'DB_COLLATION' ] == "UTF-8" )
            {
                mysqli_set_charset( $main_db_link, "utf8" );

            }
        }
        else
        {
            if ( $config[ 'ADMIN_LANGUAGE' ] == "de" )
            {
                $database -> error( "Der MySQL Datenbankserver ist nicht erreichbar" );
            }
            else
            {
                $database -> error( "The MySQL database server is not reachable" );
            }
        }
    }

    function checkconnection( $var, $var2, $var3, $var4 )
    {
        if( $main_db_link = @mysqli_connect( $var, $var2, $var3, $var4 ) )
        {
            $success = 1;
        }
        else
        {
            @mysqli_query( $main_db_link, "CREATE DATABASE " . $var4 );

            if( @mysqli_select_db( $main_db_link, $var4 ) )
            {
                $success = 1;
            }
            else
            {
                $success = 0;
            }
        }

        return $success;
    }

    function checkdatabase( $var )
    {
        global $main_db_link;

        $success = ( @mysqli_select_db(  $main_db_link, $var ) ) ? 1 : 0 ;
        return $success;
    }

    function checkinnodb()
    {
        global $main_db_link;

        $query = mysqli_query( $main_db_link, "SHOW VARIABLES like 'have_innodb'" );
        list( $variable_name, $variable_value ) = mysqli_fetch_row( $query );

        $success = ( $variable_value == "YES" ) ? 1 : 0 ;
        return $success;
    }

    function dbquery( $var )
    {
        global $main_db_link, $config, $database;

        $query = mysqli_query( $main_db_link, $var );

        if( !$query )
        {
            if ( $config[ 'ADMIN_LANGUAGE' ] == "de" )
            {
                $database -> error( "Der MySQL Datenbankserver meldet " . mysqli_errno( $main_db_link ) . ": " . mysqli_error( $main_db_link ) . " bei SQL Abfrage " . $var );
            }
            else
            {
                $database -> error( "The MySQL database server has returned " . mysqli_errno( $main_db_link ) . ": " . mysqli_error( $main_db_link ) . " while executing " . $var );
            }
        }

        return $query;
    }

    function dbquerycompat( $var )
    {
        global $main_db_link, $config, $database;

        if( mysqli_get_server_info( $main_db_link ) > "5.0" )
        {
            $var = str_replace( "TYPE=", "ENGINE=", $var );
        }

        $query = mysqli_query( $main_db_link, $var );

        if( !$query )
        {
            if ( $config[ 'ADMIN_LANGUAGE' ] == "de" )
            {
                $database -> error( "Der MySQL Datenbankserver meldet " . mysqli_errno( $main_db_link ) . ": " . mysqli_error( $main_db_link ) . " bei SQL Abfrage " . $var );
            }
            else
            {
                $database -> error( "The MySQL database server has returned " . mysqli_errno( $main_db_link ) . ": " . mysqli_error( $main_db_link ) . " while executing " . $var );
            }
        }

        return $query;
    }

    function dbqueryhidden( $var )
    {
        global $main_db_link;

        $query = @mysqli_query( $var );
        return $query;
    }

    function dbrowshidden( $var )
    {
        global $main_db_link;

        $query = @mysqli_num_rows( $var );
        return $query;
    }

    function dbrow( $var )
    {
        $query = mysqli_fetch_row( $var );
        return $query;
    }

    function dbrowf( $var )
    {
        global $database;

        $query = mysqli_fetch_row( $database -> dbquery( $var ) );
        return $query;
    }

    function dbarray( $var )
    {
        $query = mysqli_fetch_array( $var );
        return $query;
    }

    function dbrows( $var )
    {
        $query = mysqli_num_rows( $var );
        return $query;
    }

    function dbrowsf( $var )
    {
        global $database;

        $rows = mysqli_num_rows( $database -> dbquery( $var ) );
        return $rows;
    }

    function dbserver()
    {
        global $main_db_link;

        $server = "MySQL " . mysqli_get_server_info( $main_db_link );
        return $server;
    }

    function dbsize()
    {
        global $main_db_link;

        $dbsize = 0;
        $query = mysqli_query( $main_db_link, "SHOW TABLE STATUS" );
        while( $row = mysqli_fetch_array( $query ) )
        {
            $dbsize += $row[ "Data_length" ] + $row[ "Index_length" ];
        }
        return round( ( $dbsize / 1024000 ), 1 ) . " MB";
    }

    function dblastinsert()
    {
        global $main_db_link;

        $id = mysqli_insert_id( $main_db_link );
        return $id;
    }

    function dbescape( $var )
    {
        global $main_db_link;

        $var = str_replace( "\\r\\n", "\r\n", mysqli_real_escape_string( $main_db_link, $var ) );
        return $var;
    }

    function dbfescape( $var )
    {
        global $main_db_link;

        $var = mysqli_real_escape_string( $main_db_link, stripslashes( $var ) );

        return $var;
    }

    function xmlescape( $var )
    {
        $var = addslashes( rtrim( ltrim( $var ) ) );
        return $var;
    }

    function dbclose()
    {
        global $main_db_link;
        mysqli_close( $main_db_link );
    }

    function error( $var )
    {
        global $config;
        $image_dir = ( preg_match("/cadmin/i", $_SERVER[ 'PHP_SELF'] ) ) ? "../" : "" ;

        echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\">
<head>

  <meta content=\"text/html; charset=ISO-8859-1\" http-equiv=\"content-type\" />
  <meta name=\"generator\" content=\"Esselbach Contentteller CMS\" />

  ";
        if ( $config[ 'ADMIN_LANGUAGE' ] == "de" )
        {
            echo "<title>Contentteller Content Management System - MySQL Datenbankfehler</title>";
        }
        else
        {
            echo "<title>Contentteller Content Management System - MySQL database error</title>";
        }

        echo "
  <style type=\"text/css\">
body {
margin: 50px;
padding: 0px;
color: rgb(0, 0, 0);
background-color: rgb(182, 201, 218);
font-family: 'Lucida Grande', 'Bitstream Vera Sans', verdana, arial, sans-serif;
font-size: small;
line-height: normal;
font-weight: normal;
font-style: normal;
text-transform: none;
}
</style>
</head>

<body>

    <img src=\"" . $image_dir . "images/contentteller_logo.png\" alt=\"Contentteller\" />

    <br /><br />
    ";
        if ( $config[ 'ADMIN_LANGUAGE' ] == "de" )
        {
            echo "In der MySQL Datenbank dieser Contentteller Content Management System Installation ist folgendes Problem aufgetreten:<br />";
        }
        else
        {
            echo "The MySQL database of this Contentteller Content Management System installation has encountered the following problem:<br />";
        }
        echo "<strong>" . htmlspecialchars( $var, ENT_QUOTES, CT_ENCODING ) .  "</strong><br /><br />";
        if ( $config[ 'ADMIN_LANGUAGE' ] == "de" )
        {
            echo "Bitte versuchen Sie es in einigen Minuten erneut.";
        }
        else
        {
            echo "Please try it in a few minutes again. We apologize for any inconvenience.";
        }
        echo "
</body>
</html>";
        exit;
    }
}
?>