<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #3                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage System
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */
class system
{

	function statusbar( $var, $var2 )
	{
		global $user, $templates, $preferences;

		if( ( $user[ 'user_username' ] ) && ( $user[ 'user_session' ] ) )
		{
			$insert[ 'user_username' ] = $user[ 'user_username' ];
			$bar = $templates -> exectemplate( $var[ 'site_login_user_html' ], $var[ 'site_login_user_php' ], $insert );
		}
		else
		{
			$bar = $templates -> exectemplate( $var[ 'site_login_anon_html' ], $var[ 'site_login_anon_php' ], $var2 );
		}

		return $bar;
	}

	function getstatus()
	{
		global $user, $database;

		if( ( $user[ 'user_username' ] ) && ( $user[ 'user_session' ] ) )
		{
			$query = $database -> dbquery( "SELECT user_status FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_name = '". $user[ 'user_username' ] ."'" );
			list( $status ) = $database -> dbrow( $query );
		}
		else
		{
			$status = 0;
		}

		return $status;
	}

	function getdir( $var )
	{
		$dir = array();
		$file = "";

		if( file_exists( "$var" ) )
		{
			$od = opendir( $var );

			while( $file = readdir( $od ) )
			{
				array_push( $dir, "$file" );
			}

			closedir( $od );
			sort( $dir );
		}

		return $dir;
	}

	function description( $var )
	{
		global $preferences;

		$var = preg_replace( "/\[(.*?)\]/", "", strip_tags( $var ) );
		if( phpversion() >= "4.3.0" )
		{
			$var = html_entity_decode( $var );
			$var = htmlspecialchars( $var, ENT_QUOTES, CT_ENCODING );
		}

		if( $preferences[ 'website_charset' ] == "UTF-8" )
		{
			$var = mb_convert_encoding( $var, "UTF-8" );
		}
		$var = str_replace( "\r\n", " ", $var );
		$var = substr( $var, 0, 200 ) . "...";

		return $var;
	}

	function keywords( $var )
	{
		global $preferences;

		$keywords = array();
		if( phpversion() >= "4.3.0" )
		{
			$var = html_entity_decode( $var );
			$var = htmlspecialchars( $var, ENT_QUOTES, CT_ENCODING );
		}
		if( $preferences[ 'website_charset' ] == "UTF-8" )
		{
			$var = mb_convert_encoding( $var, "UTF-8" );
		}
		$words = explode( " ", preg_replace( "/\[(.*?)\]/", "", strip_tags( $var ) ) );

		for( $i = 0; $i < count( $words ); $i++ )
		{
			if( strlen( $words[ $i ] ) > 3 )
			{
				$keywords[ ] = $words[ $i ];
			}
		}

		sort( $keywords );
		$linewords = 0;
		$returndata = 0;

		for( $i = 0; $i < count( $keywords ); $i++ )
		{
			if( ( @!preg_match( "/" . $keywords[ $i ] . "/", $returndata ) ) and( @!preg_match( "/^\W|,|\"|\.|\n|<|>|'|\/|!|\)|\(|:|;/i", $keywords[ $i ] ) ) )
			{
				if( $linewords < 60 )
				{
					$returndata .= $keywords[ $i ] . ", ";
					$linewords++;
				}
			}
		}

		$returndata = substr( $returndata, 1, -2 );
		return $returndata;
	}

	function tags( $var )
	{
		global $preferences;

		$tags = array();
		if( phpversion() >= "4.3.0" )
		{
			$var = html_entity_decode( $var );
			$var = htmlspecialchars( $var, ENT_QUOTES, CT_ENCODING );
		}
		if( $preferences[ 'website_charset' ] == "UTF-8" )
		{
			$var = mb_convert_encoding( $var, "UTF-8" );
		}
		$words = explode( " ", preg_replace( "/\[(.*?)\]/", "", strip_tags( $var ) ) );

		for( $i = 0; $i < count( $words ); $i++ )
		{
			if( strlen( $words[ $i ] ) > 5 and !preg_match( "/[0-9]/i", $words[ $i ] ) )
			{
				$tags[ ] = $words[ $i ];
			}
		}

		sort( $tags );
		$returndata = implode( ",", $tags );
		return $returndata;
	}

	function fixbreaks( $var )
	{
		$var = str_replace( "\n", "\\n", $var );
		return $var;
	}

	function convertbreaks( $var )
	{
		$var = str_replace( "\n", "<br />", $var );
		return $var;
	}

	function trimpath( $var )
	{
		if( substr( $var, -1 ) == "/" )
		{
			$var = substr( $var, 0, -1 );
		}
		return $var;
	}

	function smilies( $var )
	{
		global $smilie_command_cache, $smilie_image_cache, $database;

		if( !is_array( $smilie_command_cache ) )
		{
			$query = $database -> dbquery( "SELECT smilie_command, smilie_image FROM " . DB_PREFIX . "esselbach_ct_smilies WHERE smilie_active = '1'" );

			while( list( $command, $image ) = $database -> dbrow( $query ) )
			{
				$smilie_command_cache[ ] = $command;
				$smilie_image_cache[ ] = $image;
			}
		}

		for( $i = 0; $i < count( $smilie_command_cache ); $i++ )
		{
			$path = ( preg_match( "/http/i", $smilie_image_cache[ $i ] ) ) ? "" : "images/smilies/" ;
			$var = str_replace( $smilie_command_cache[ $i ], " <img src=\"" . $path . $smilie_image_cache[ $i ] . "\" alt=\"" . $smilie_command_cache[ $i ] . "\" />", $var );
		}

		return $var;
	}

	function code( $var )
	{
		global $system, $database, $preferences;
		$var = $system -> checkcode( "[quote]", "[/quote]", $var );
		$var = $system -> checkcode( "[code]", "[/code]", $var );
		$var = $system -> checkcode( "[b]", "[/b]", $var );
		$var = $system -> checkcode( "[i]", "[/i]", $var );
		$var = $system -> checkcode( "[u]", "[/u]", $var );
		$var = $system -> checkcode( "[marquee]", "[/marquee]", $var );
		$var = $system -> checkcode( "[s]", "[/s]", $var );
		$var = $system -> checkcode( "[sup]", "[/sup]", $var );
		$var = $system -> checkcode( "[sub]", "[/sub]", $var );
		$var = $system -> checkcode( "[tt]", "[/tt]", $var );
		$var = $system -> checkcode( "[center]", "[/center]", $var );
		$var = $system -> checkcode( "[left]", "[/left]", $var );
		$var = $system -> checkcode( "[right]", "[/right]", $var );
		$var = $system -> checkcode( "[QUOTE]", "[/QUOTE]", $var );
		$var = $system -> checkcode( "[CODE]", "[/CODE]", $var );
		$var = $system -> checkcode( "[B]", "[/B]", $var );
		$var = $system -> checkcode( "[I]", "[/I]", $var );
		$var = $system -> checkcode( "[U]", "[/U]", $var );
		$var = $system -> checkcode( "[MARQUEE]", "[/MARQUEE]", $var );
		$var = $system -> checkcode( "[S]", "[/S]", $var );
		$var = $system -> checkcode( "[SUP]", "[/SUP]", $var );
		$var = $system -> checkcode( "[SUB]", "[/SUB]", $var );
		$var = $system -> checkcode( "[TT]", "[/TT]", $var );
		$var = $system -> checkcode( "[CENTER]", "[/CENTER]", $var );
		$var = $system -> checkcode( "[LEFT]", "[/LEFT]", $var );
		$var = $system -> checkcode( "[RIGHT]", "[/RIGHT]", $var );
		$query = $database -> dbquery( "SELECT code_search, code_replace FROM " . DB_PREFIX . "esselbach_ct_blockcode WHERE code_active = '1'" );

		if( $database -> dbrows( $query ) )
		{
			while( list( $search, $replace ) = $database -> dbrow( $query ) )
			{
				$var = str_replace( $search, $replace, $var );
			}
		}

		$var = str_replace( array( "[quote]", "[/quote]", "[code]", "[/code]", "[b]", "[/b]", "[i]", "[/i]", "[u]", "[/u]", "[marquee]", "[/marquee]", "[s]", "[/s]", "[sup]", "[/sup]", "[sub]", "[/sub]", "[tt]", "[/tt]", "[center]", "[/center]", "[left]", "[/left]", "[right]", "[/right]", "[QUOTE]", "[/QUOTE]", "[CODE]", "[/CODE]", "[B]", "[/B]", "[I]", "[/I]", "[U]", "[/U]", "[MARQUEE]", "[/MARQUEE]", "[S]", "[/S]", "[SUP]", "[/SUP]", "[SUB]", "[/SUB]", "[TT]", "[/TT]", "[CENTER]", "[/CENTER]", "[LEFT]", "[/LEFT]", "[RIGHT]", "[/RIGHT]"), array( "<div class=\"quoteblock\">", "</div>", "<div class=\"codeblock\">", "</div>", "<strong>", "</strong>", "<i>", "</i>", "<u>", "</u>", "<marquee>", "</marquee>", "<s>", "</s>", "<sup>", "</sup>", "<sub>", "</sub>", "<tt>", "</tt>", "<div style=\"text-align: center;\">", "</div>", "<div style=\"text-align: left;\">", "</div>", "<div style=\"text-align: right;\">", "</div>", "<div class=\"quoteblock\">", "</div>", "<div class=\"codeblock\">", "</div></table>", "<strong>", "</strong>", "<i>", "</i>", "<u>", "</u>", "<marquee>", "</marquee>", "<s>", "</s>", "<sup>", "</sup>", "<sub>", "</sub>", "<tt>", "</tt>", "<div style=\"text-align: center;\">", "</div>", "<div style=\"text-align: left;\">", "</div>", "<div style=\"text-align: right;\">", "</div>" ), $var );
		$var = preg_replace( array( "/\[url\](.*?)\[\/url\]/", "/\[URL\](.*?)\[\/URL\]/", "/\[img\](.*?)\[\/img\]/", "/\[imgleft\](.*?)\[\/imgleft\]/",	"/\[imgright\](.*?)\[\/imgright\]/", "/\[IMG\](.*?)\[\/IMG\]/", "/\[IMGLEFT\](.*?)\[\/IMGLEFT\]/", "/\[IMGRIGHT\](.*?)\[\/IMGRIGHT\]/", "/\[email\](.*?)\[\/email\]/",	"/\[EMAIL\](.*?)\[\/EMAIL\]/", "/\[url=http:\/\/(.*?)\](.*?)\[\/url\]/", "/\[url=www.(.*?)\](.*?)\[\/url]/", "/\[url=https:\/\/(.*?)\](.*?)\[\/url\]/", "/\[url=ftp:\/\/(.*?)\](.*?)\[\/url\]/", "/\[url=ftp\.(.*?)\](.*?)\[\/url\]/", "/\[URL=http:\/\/(.*?)\](.*?)\[\/URL\]/", "/\[URL=www.(.*?)\](.*?)\[\/URL\]/", "/\[URL=https:\/\/(.*?)\](.*?)\[\/URL\]/", "/\[URL=ftp:\/\/(.*?)\](.*?)\[\/URL\]/", "/\[URL=ftp.(.*?)\](.*?)\[\/URL\]/", "/\[email=(.*?)\](.*?)\[\/email\]/", "/\[EMAIL=(.*?)\](.*?)\[\/EMAIL\]/", "/\[size=(.*?)\](.*?)\[\/size\]/", "/\[font=(.*?)\](.*?)\[\/font\]/", "/\[color=(.*?)\](.*?)\[\/color\]/", "/\[SIZE=(.*?)\](.*?)\[\/SIZE\]/", "/\[FONT=(.*?)\](.*?)\[\/FONT\]/", "/\[COLOR=(.*?)\](.*?)\[\/COLOR\]/", "/\[url='http:\/\/(.*?)'\](.*?)\[\/url\]/", "/\[url=\"http:\/\/(.*?)\"\](.*?)\[\/url\]/",  "/\[URL='http:\/\/(.*?)'\](.*?)\[\/URL\]/", "/\[URL=\"http:\/\/(.*?)\"\](.*?)\[\/URL\]/", "/\[url=&quot;http:\/\/(.*?)&quot;\](.*?)\[\/url\]/", "/\[URL=&quot;http:\/\/(.*?)&quot;\](.*?)\[\/URL\]/" ), array( "<a href=\"\\1\" rel=\"nofollow\">\\1</a>", "<a href=\"\\1\" rel=\"nofollow\">\\1</a>", "<img src=\"\\1\" alt=\"\" />", "<img src=\"\\1\" class=\"left\" alt=\"\" />", "<img src=\"\\1\" class=\"right\" alt=\"\" />", "<img src=\"\\1\" alt=\"\" />",	"<img src=\"\\1\" class=\"left\" alt=\"\" />", "<img src=\"\\1\" class=\"right\" alt=\"\" />", "<a href=\"mailto:\\1\">\\1</a>", "<a href=\"mailto:\\1\">\\1</a>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://www.\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"https://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"ftp://\\1\" rel=\"nofollow\">\\2</a>",	"<a href=\"ftp://ftp.\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://www.\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"https://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"ftp://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"ftp://ftp.\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"mailto:\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"mailto:\\1\" rel=\"nofollow\">\\2</a>",	"<div style=\"display:inline; font-size: \\1\">\\2</div>", "<div style=\"display:inline; font-family: \\1\">\\2</div>", "<div style=\"display:inline; color: \\1\">\\2</div>", "<div style=\"display:inline; font-size: \\1\">\\2</div>", "<div style=\"display:inline; font-family: \\1\">\\2</div>", "<div style=\"display:inline; color: \\1\">\\2</div>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>", "<a href=\"http://\\1\" rel=\"nofollow\">\\2</a>" ), $var );

		if( $preferences[ 'website_youtube_size' ] == "640x385" )
		{
			$youtube_size = "width=\"640\" height=\"385\"";
		}
		elseif( $preferences[ 'website_youtube_size' ] == "853x505" )
		{
			$youtube_size = "width=\"853\" height=\"505\"";
		}
		elseif( $preferences[ 'website_youtube_size' ] == "1280x745" )
		{
			$youtube_size = "width=\"1280\" height=\"745\"";
		}
		else
		{
			$youtube_size = "width=\"560\" height=\"340\"";
		}

		$var = preg_replace( array( "/\[lefttext=(.*?)\](.*?)\[\/lefttext\]/", "/\[righttext=(.*?)\](.*?)\[\/righttext\]/" ), array( "<div class=\"lefttext\"><img src=\"\\1\" alt=\"\" /><br />\\2</div>", "<div class=\"righttext\"><img src=\"\\1\" alt=\"\" /><br />\\2</div>" ), $var );

		$var = preg_replace( "/\[youtube=([a-zA-Z0-9-_]+)\]|\[YOUTUBE=([a-zA-Z0-9-_]+)\]/", "<object " . $youtube_size . "><param name=\"movie\" value=\"http://www.youtube.com/v/\\1\"></param><param name=\"wmode\" value=\"transparent\"></param><embed src=\"http://www.youtube.com/v/\\1\" type=\"application/x-shockwave-flash\" wmode=\"transparent\" " . $youtube_size . "></embed></object>", $var );
		$var = preg_replace( "/\[dailymotion=([a-zA-Z0-9-_]+)\]|\[DAILYMOTION=([a-zA-Z0-9-_]+)\]/", "<object width=\"560\" height=\"340\"><param name=\"movie\" value=\"http://www.dailymotion.com/swf/\\1\"></param><param name=\"allowfullscreen\" value=\"true\"></param><embed src=\"http://www.dailymotion.com/swf/\\1\" type=\"application/x-shockwave-flash\" width=\"560\" height=\"340\" allowfullscreen=\"true\"></embed></object>", $var );
		$var = preg_replace( "/\[googlevideo=([a-zA-Z0-9-_]+)\]|\[GOOGLEVIDEO=([a-zA-Z0-9-_]+)\]/", "<embed style=\"width:425px; height:350px;\" id=\"VideoPlayback\" type=\"application/x-shockwave-flash\" src=\"http://video.google.com/googleplayer.swf?docId=\\1&hl=en\" flashvars=\"\"></embed>", $var );
		$var = preg_replace( "/\[yahoovideo=([a-zA-Z0-9-_]+)\]|\[YAHOOVIDEO=([a-zA-Z0-9-_]+)\]/", "<embed src=\"http://us.i1.yimg.com/cosmos.bcst.yahoo.com/player/media/swf/FLVVideoSolo.swf\" flashvars=\"id=\\1\" type=\"application/x-shockwave-flash\" width=\"425\" height=\"350\"></embed>", $var );
		$var = preg_replace( "/\[vimeo=([a-zA-Z0-9-_]+)\]|\[VIMEO=([a-zA-Z0-9-_]+)\]/", "<object width=\"640\" height=\"360\"><param name=\"allowfullscreen\" value=\"true\" /><param name=\"allowscriptaccess\" value=\"always\" /><param name=\"movie\" value=\"http://vimeo.com/moogaloop.swf?clip_id=\\1&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color=&amp;fullscreen=1\" /><embed src=\"http://vimeo.com/moogaloop.swf?clip_id=\\1&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=0&amp;color=&amp;fullscreen=1\" type=\"application/x-shockwave-flash\" allowfullscreen=\"true\" allowscriptaccess=\"always\" width=\"640\" height=\"360\"></embed></object>", $var );
		$var = preg_replace( "/\[myspace=([a-zA-Z0-9-_]+)\]|\[MYSPACE=([a-zA-Z0-9-_]+)\]/", "<embed src=\"http://lads.myspace.com/videos/vplayer.swf\" flashvars=\"m=\\1&amp;v=2&amp;type=video\" type=\"application/x-shockwave-flash\" width=\"425\" height=\"350\"></embed>", $var );
		$var = preg_replace( "/\[break=([a-zA-Z0-9-_]+)\]|\[BREAK=([a-zA-Z0-9-_]+)\]/", "<object width=\"425\" height=\"350\"><param name=\"movie\" value=\"http://embed.break.com/\\1\"></param><embed src=\"http://embed.break.com/\\1\" type=\"application/x-shockwave-flash\" width=\"425\" height=\"350\"></embed></object>", $var );
		$var = preg_replace( "/\[revver=([a-zA-Z0-9-_]+)\]|\[REVVER=([a-zA-Z0-9-_]+)\]/", "<embed type=\"application/x-shockwave-flash\" src=\"http://flash.revver.com/player/1.0/player.swf\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" scale=\"noScale\" salign=\"TL\" bgcolor=\"#ffffff\" flashvars=\"mediaId=\\1\" wmode=\"transparent\" height=\"350\" width=\"425\"></embed>", $var );
		$var = preg_replace( "/\[liveleak=([a-zA-Z0-9-_]+)\]|\[LIVELEAK=([a-zA-Z0-9-_]+)\]/", "<object type=\"application/x-shockwave-flash\" width=\"425\" height=\"350\" wmode=\"transparent\" data=\"http://www.liveleak.com/player.swf?autostart=false&token=\\1\"><param name=\"movie\" value=\"http://www.liveleak.com/player.swf?autostart=false&token=\\1\"><param name=\"wmode\" value=\"transparent\"><param name=\"quality\" value=\"high\"></object>", $var );
		$var = preg_replace( "/\[metacafe=([a-zA-Z0-9-_]+)\]|\[METACAFE=([a-zA-Z0-9-_]+)\]/", "<object type=\"application/x-shockwave-flash\" width=\"400\" height=\"345\" data=\"http://www.metacafe.com/fplayer/\\1.swf\"><param name=\"movie\" value=\"http://www.metacafe.com/fplayer/\\1.swf\" /><param name=\"wmode\" value=\"transparent\" /></object>", $var );
		$var = preg_replace( "/\[loowa=([a-zA-Z0-9-_]+)\]|\[LOOWA=([a-zA-Z0-9-_]+)\]/", "<embed src=\"http://update.videoegg.com/flash/player8.swf?jsver=1.3\" FlashVars=\"file=http%3A//selfserve1.download.videoegg.com/gid353/cid1208/CZ/PW/1169094106KzyWvMT0WVB7S74rN6a2&amp;bgColor=000000&amp;autoPlay=false&amp;showAd=false&amp;adVars=&amp;pageURL=http%3A//www.loowa.com/video/\\1&amp;allowFlash9Fullscreen=true\" quality=\"high\" allowFullScreen=\"true\" allowScriptAccess=\"always\" bgcolor=\"#000000\" scale=\"noscale\" wmode=\"window\" width=\"425\" height=\"350\" name=\"VE_Player\" align=\"middle\" type=\"application/x-shockwave-flash\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\"></embed>", $var );
		$var = preg_replace( "/\[superdeluxe=([a-zA-Z0-9-_]+)\]|\[SUPERDELUXE=([a-zA-Z0-9-_]+)\]/", "<object width=\"425\" height=\"350\"><param name=\"allowFullScreen\" value=\"true\" /><param name=\"movie\" value=\"http://www.superdeluxe.com/static/swf/share_vidplayer.swf\" /><param name=\"FlashVars\" value=\"id=\\1\" /><embed src=\"http://www.superdeluxe.com/static/swf/share_vidplayer.swf\" FlashVars=\"id=\\1\" type=\"application/x-shockwave-flash\" width=\"425\" height=\"350\" allowFullScreen=\"true\" ></embed></object>", $var );
		$var = preg_replace( "/\[hulu=([a-zA-Z0-9-_]+)\]|\[HULU=([a-zA-Z0-9-_]+)\]/", "<object type=\"application/x-shockwave-flash\" width=\"512\" height=\"296\" data=\"http://www.hulu.com/embed/\\1\"><param name=\"movie\" value=\"http://www.hulu.com/embed/\\1\" /><param name=\"wmode\" value=\"transparent\" /></object>", $var );
		$var = preg_replace( "/\[facebook=([a-zA-Z0-9-_]+)\]|\[FACEBOOK=([a-zA-Z0-9-_]+)\]/", "<object type=\"application/x-shockwave-flash\" width=\"576\" height=\"432\" data=\"http://www.facebook.com/v/\\1\"><param name=\"movie\" value=\"http://www.facebook.com/v/\\1\" /><param name=\"wmode\" value=\"transparent\" /></object>", $var );
		return $var;
	}

	function fixsmilies( $var )
	{
		$var = str_replace( " <img src=\"images/smilies/", " <img src=\"../images/smilies/", $var );
		return $var;
	}

	function attachments( $var, $var2 )
	{
	    global $preferences, $words_core, $database;

	    $seo_url = $preferences[ 'website_url' ] . "/" ;
	    $seo_url .= ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "index" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;

   	    $var = preg_replace( "/\[attachment=(.*?)\](.*?)\[\/attachment\]/", "<a href=\"index.php?ct=" . $var2 . "&amp;action=file&amp;id=\\1\">\\2</a>", $var );
   	    preg_match_all("/\[fullimage=(.*?)\]|\[fullimageleft=(.*?)\]|\[fullimageright=(.*?)\]|\[thumb=(.*?)\]|\[thumbleft=(.*?)\]|\[thumbright=(.*?)\]/i", $var, $matches, PREG_SET_ORDER);

		foreach( $matches as $match )
		{
		    if( $match[1] ) $this_match = $match[1];
		    if( $match[2] ) $this_match = $match[2];
		    if( $match[3] ) $this_match = $match[3];
		    if( $match[4] ) $this_match = $match[4];
		    if( $match[5] ) $this_match = $match[5];
		    if( $match[6] ) $this_match = $match[6];

		    if( $var2 == "content" )
		    {
		        $query = $database -> dbquery( "SELECT contentfile_id, contentfile_filename FROM " . DB_PREFIX . "esselbach_ct_contentfiles WHERE contentfile_id = '" . intval( $this_match ) . "'" );
		        list( $id, $filename ) = $database -> dbrow( $query );
		        $var = str_replace( array( "[fullimage=" . $id . "]", "[fullimageleft=" . $id . "]", "[fullimageright=" . $id . "]", "[thumb=" . $id . "]", "[thumbleft=" . $id . "]", "[thumbright=" . $id . "]" ), array( "<img src=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" alt=\"\" />", "<img src=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"left\" alt=\"\" />", "<img src=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"right\" alt=\"\" />", "<a href=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumb\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbleft\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "content" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbright\" alt=\"\" /></a>" ), $var );
		    }
		    if( $var2 == "news" )
		    {
		        $query = $database -> dbquery( "SELECT newsfile_id, newsfile_filename FROM " . DB_PREFIX . "esselbach_ct_newsfiles WHERE newsfile_id = '" . intval( $this_match ) . "'" );
		        list( $id, $filename ) = $database -> dbrow( $query );
		        $var = str_replace( array( "[fullimage=" . $id . "]", "[fullimageleft=" . $id . "]", "[fullimageright=" . $id . "]", "[thumb=" . $id . "]", "[thumbleft=" . $id . "]", "[thumbright=" . $id . "]" ), array( "<img src=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" alt=\"\" />", "<img src=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"left\" alt=\"\" />", "<img src=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"right\" alt=\"\" />", "<a href=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumb\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbleft\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "news" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbright\" alt=\"\" /></a>" ), $var );
		    }
		    if( $var2 == "articles" )
		    {
		        $query = $database -> dbquery( "SELECT articlefile_id, articlefile_filename FROM " . DB_PREFIX . "esselbach_ct_articlesfiles WHERE articlefile_id = '" . intval( $this_match ) . "'" );
		        list( $id, $filename ) = $database -> dbrow( $query );
		        $var = str_replace( array( "[fullimage=" . $id . "]", "[fullimageleft=" . $id . "]", "[fullimageright=" . $id . "]", "[thumb=" . $id . "]", "[thumbleft=" . $id . "]", "[thumbright=" . $id . "]" ), array( "<img src=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" alt=\"\" />", "<img src=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"left\" alt=\"\" />", "<img src=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"right\" alt=\"\" />", "<a href=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumb\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbleft\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbright\" alt=\"\" /></a>" ), $var );
		    }
		    if( $var2 == "files" )
		    {
		        $query = $database -> dbquery( "SELECT filefile_id, filefile_filename FROM " . DB_PREFIX . "esselbach_ct_filesfiles WHERE filefile_id = '" . intval( $this_match ) . "'" );
		        list( $id, $filename ) = $database -> dbrow( $query );
		        $var = str_replace( array( "[fullimage=" . $id . "]", "[fullimageleft=" . $id . "]", "[fullimageright=" . $id . "]", "[thumb=" . $id . "]", "[thumbleft=" . $id . "]", "[thumbright=" . $id . "]" ), array( "<img src=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" alt=\"\" />", "<img src=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"left\" alt=\"\" />", "<img src=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"right\" alt=\"\" />", "<a href=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumb\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbleft\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbright\" alt=\"\" /></a>" ), $var );
		    }
		    if( $var2 == "knowledgebase" )
		    {
		        $query = $database -> dbquery( "SELECT knowledgebasefile_id, knowledgebasefile_filename FROM " . DB_PREFIX . "esselbach_ct_knowledgebasefiles WHERE knowledgebasefile_id = '" . intval( $this_match ) . "'" );
		        list( $id, $filename ) = $database -> dbrow( $query );
		        $var = str_replace( array( "[fullimage=" . $id . "]", "[fullimageleft=" . $id . "]", "[fullimageright=" . $id . "]", "[thumb=" . $id . "]", "[thumbleft=" . $id . "]", "[thumbright=" . $id . "]" ), array( "<img src=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" alt=\"\" />", "<img src=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"left\" alt=\"\" />", "<img src=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "file" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"right\" alt=\"\" />", "<a href=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumb\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbleft\" alt=\"\" /></a>", "<a href=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . $id . ".html\" title=\"" . $words_core[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "thumb" . $preferences[ 'param_page' ] . $id . "_" . $filename . "\" class=\"thumbright\" alt=\"\" /></a>" ), $var );
		    }
		}
		return $var;
	}

	function getvariables()
	{
		global $preferences;

		if ( $preferences[ 'website_mod_rewrite' ] )
		{
			$port = ( $_SERVER[ 'SERVER_PORT' ] != "80" ) ? ":" . $_SERVER[ 'SERVER_PORT' ] : "" ;
			$request = str_replace( $preferences[ 'website_url' ] . "/", "", "http://" . $_SERVER[ 'SERVER_NAME' ] . $port . $_SERVER[ 'REQUEST_URI' ] );

            if( $_SERVER[ 'SERVER_PORT' ] == "443" )
            {
                 $request = str_replace( $preferences[ 'website_url' ] . "/", "", "https://" . $_SERVER[ 'SERVER_NAME' ] . $_SERVER[ 'REQUEST_URI' ] );
            }
		}
		elseif( $preferences[ 'website_forcetype' ] )
		{
			$port = ( $_SERVER[ 'SERVER_PORT' ] != "80" ) ? ":" . $_SERVER[ 'SERVER_PORT' ] : "" ;
			$request = str_replace( array( $preferences[ 'website_url' ], "/contentteller/" ), "", "http://" . $_SERVER[ 'SERVER_NAME' ] . $port . $_SERVER[ 'REQUEST_URI' ] );
		}
		else
		{
			$request = substr( ( $_SERVER[ 'QUERY_STRING' ] ) ? $_SERVER[ 'QUERY_STRING' ] : $_SERVER[ 'PATH_INFO' ], 1 );
		}
		$variable_array = explode( "/", str_replace( "-", "_", $request ) );

		return $variable_array;
	}

	function checkcode( $var, $var2, $var3 )
	{
		global $system;
		$code_open = $system -> supercount( $var, $var3 );
		$code_close = $system -> supercount( $var2, $var3 );

		if( $code_open != $code_close )
		{
			$var3 = str_replace( $var, "", $var3 );
			$var3 = str_replace( $var2, "", $var3 );
		}

		return $var3;
	}

	function convertdate( $var, $var2, $var3 )
	{
		$story_date_array = explode( " ", $var );
		$story_date = explode( "-", $story_date_array[ 0 ] );
		$story_time = explode( ":", $story_date_array[ 1 ] );
		$story_date = mktime( $story_time[ 0 ], $story_time[ 1 ], $story_time[ 2 ], $story_date[ 1 ], $story_date[ 2 ], $story_date[ 0 ] );
		$offset_minutes = substr( $var3, 1, 1 ) * 60;
		$offset_seconds = $offset_minutes * 60;

		if( substr( $var3, 0, 1 ) == "+" )
		{
			$story_date = $story_date + $offset_seconds;
		}
		elseif( substr( $var3, 0, 1 ) == "-" )
		{
			$story_date = $story_date - $offset_seconds;
		}

		return gmstrftime( $var2, $story_date );
	}

	function getmonth( $var )
	{
		$story_date_array = explode( " ", $var );
		$story_date = explode( "-", $story_date_array[ 0 ] );
		$var = $story_date[ 0 ] . $story_date[ 1 ];
		return $var;
	}

	function decode( $var )
	{
		$var = htmlspecialchars( base64_decode( $var ), ENT_QUOTES, CT_ENCODING );
		return $var;
	}

	function write( $var, $var2 )
	{
		header( "Content-Type: image/png" );
		header( "Content-Length: " . strlen( base64_decode( $var ) ) );
	    header( "Content-Disposition: attachment; filename=\"" . $var2 . ".png\"");
		echo base64_decode( $var );
		exit;
	}

	function scriptex( $var )
	{
		$var = preg_replace( "/javascript/i", "java&nbsp;script&nbsp;", $var );
		$var = preg_replace( "/vbscript/i", "vb&nbsp;script&nbsp;", $var );
		$var = preg_replace( "/about:/i", "about&nbsp;:", $var );
		$var = preg_replace( "/JavaScript/i", "Java&nbsp;Script&nbsp;", $var );
		$var = preg_replace( "/VBScript/i", "vb&nbsp;script&nbsp;", $var );
		return $var;
	}

	function dechomp( $var )
	{
		$var = str_replace( array( "\r\n", "\n" ), "<br />", htmlspecialchars( $var, ENT_QUOTES, CT_ENCODING ) );
		return $var;
	}

	function rechomp( $var )
	{
		$var = str_replace( "<br />", "\n", $var );
		$var = str_replace( "&lt;", "<", $var );
		$var = str_replace( "&gt;", ">", $var );
		return $var;
	}

	function utf8( $var )
	{
	    global $config;
	    $var = ( $config[ 'DB_COLLATION' ] == "UTF-8" ) ? utf8_encode( $var ) : $var ;
	    return $var;
	}

	function html( $var )
	{
		$var = str_replace( "../jscripts/tiny_mce", "jscripts/tiny_mce", $var );
		return $var;
	}

	function getip()
	{
		global $preferences;

		$var = ( $preferences[ 'website_anon_ip' ] ) ? "0.0.0.0" : addslashes( $_SERVER[ "REMOTE_ADDR" ] ) ;
		return $var;
	}

	function getreferrer()
	{
		$var = addslashes( $_SERVER[ "HTTP_REFERER" ] );
		return $var;
	}

	function getagent()
	{
		$var = addslashes( $_SERVER[ "HTTP_USER_AGENT" ] );
		return $var;
	}

	function resizeimage( $var, $var2, $var3, $var4, $var5, $var6 )
	{
		global $preferences;

		if( function_exists( "imagecreatefromstring" ) )
		{
			$contentfile_image = imagecreatefromstring( $var );
			$contentfile_width = imagesx( $contentfile_image );
			$contentfile_height = imagesy( $contentfile_image );
			$contentfile_twidth = $var3;

			if( $contentfile_twidth > $contentfile_width )
			{
				$contentfile_twidth = $contentfile_width;
			}

			$contentfile_theight = ceil( $contentfile_height*$contentfile_twidth/$contentfile_width );

			if( function_exists( "imagecreatetruecolor" ) )
			{
				$contentfile_thumb = imagecreatetruecolor( $contentfile_twidth, $contentfile_theight );
				imagealphablending( $contentfile_thumb, false );
				imagesavealpha( $contentfile_thumb, true );
				$contentfile_transparency = imagecolorallocatealpha( $contentfile_thumb, 255, 255, 255, 127 );
				imagefilledrectangle( $contentfile_thumb, 0, 0, $contentfile_twidth, $contentfile_theight, $contentfile_transparency );
				imagecopyresampled( $contentfile_thumb, $contentfile_image, 0, 0, 0, 0,  $contentfile_twidth, $contentfile_theight, $contentfile_width, $contentfile_height );
			}
			else
			{
				$contentfile_thumb = imagecreate( $contentfile_twidth, $contentfile_theight );
				$contentfile_background = imagecolorallocate( $contentfile_thumb, 255, 255, 255 );
				imagefill( $contentfile_thumb, 0, 0, $contentfile_background );
				imagecopyresized( $contentfile_thumb, $contentfile_image, 0, 0, 0, 0, $contentfile_twidth, $contentfile_theight, $contentfile_width, $contentfile_height );
			}

			if( $var4 )
			{
				if( $var5 == "White" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 255, 255, 255 );
				}

				if( $var5 == "Block" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 0, 0, 0 );
				}

				if( $var5 == "Red" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 255, 0, 0 );
				}

				if( $var5 == "Green" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 0, 255, 0 );
				}

				if( $var5 == "Blue" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 12, 0, 253 );
				}

				if( $var5 == "Yellow" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 254, 239, 0 );
				}

				if( $var5 == "Purple" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 102, 0, 153 );
				}

				if( $var5 == "Cyan" )
				{
					$textcolor = imagecolorallocate( $contentfile_thumb, 0, 254, 239 );
				}

				imagestring( $contentfile_thumb, 4, 1,( $contentfile_theight - 16 ), $var4, $textcolor );
			}

			if( !preg_match( "/http/i", $preferences[ 'website_watermark_path' ] ) )
			{
				$watermark_path = "../" . $preferences[ 'website_watermark_path' ];
			}
			else
			{
				$watermark_path = $preferences[ 'website_watermark_path' ];
			}

			if( $var6 and file_exists( $watermark_path ) )
			{
				$filetype = substr( $watermark_path, strlen( $watermark_path )-4, 4);
				$filetype = strtolower($filetype);

				if( $filetype == ".gif" )
				{
					$watermark = imagecreatefromgif( $watermark_path );
				}
				elseif( $filetype == ".jpg" )
				{
					$watermark = imagecreatefromjpeg( $watermark_path );
				}
				elseif( $filetype == ".png" )
				{
					$watermark = imagecreatefrompng( $watermark_path );
				}

				$watermark_width = imagesx($watermark);
				$watermark_height = imagesy($watermark);
				$position_width = ( $contentfile_twidth - $watermark_width );
				$position_height = ( $contentfile_theight - $watermark_height );
				imagecopy($contentfile_thumb, $watermark, $position_width, $position_height, 0, 0, $watermark_width, $watermark_height);
			}

			ob_start();

			if( preg_match( "/jpeg/i", $var2 ) )
			{
				imagejpeg( $contentfile_thumb );
			}

			if( preg_match( "/gif/i", $var2 ) and function_exists( "imagegif" ) )
			{
				imagegif( $contentfile_thumb );
			}

			if( preg_match( "/png/i", $var2 ) )
			{
				imagepng( $contentfile_thumb );
			}

			$image_data = ob_get_contents();
			ob_end_clean();

			if( !function_exists( "imagegif" ) )
			{
				$image_data = "";
			}
		}
		else
		{
			$image_data = "";
		}

		return $image_data;
	}

	function stripthis( $var )
	{
		if( get_magic_quotes_gpc() )
		{
			$var = stripslashes( $var );
		}

		return $var;
	}

	function stripthisarray( $var )
	{
		for( $i = 0; $i < count( $var ); $i++ )
		{
			if( isset( $var[ $i ] ) )
			{
				if( get_magic_quotes_gpc() )
				{
					$var[ $i ] = stripslashes( $var[ $i ] );
				}
			}
		}

		return $var;
	}

	function hashpass( $var )
	{
		if( phpversion() >= "5.1.2" )
		{
			$var = hash( "sha512", $var );
		}
		elseif( phpversion() >= "4.3.0" )
		{
			$var = sha1( $var );
		}
		else
		{
			$var = md5( $var );
		}

		return $var;
	}

	function supercount( $var, $var2 )
	{
		$var = str_replace( "/", "Un", $var );
		$var = str_replace( "[", "Lf", $var );
		$var = str_replace( "]", "Rg", $var );
		$var2 = str_replace( "/", "Un", $var2 );
		$var2 = str_replace( "[", "Lf", $var2 );
		$var2 = str_replace( "]", "Rg", $var2 );
		$myarray = preg_split( "/[\s,]+/", $var2 );
		$found = 0;

		for( $i = 0; $i < count( $myarray ); $i++ )
		{
			if( preg_match( "/" . $var . "/i", $myarray[ $i ] ) )
			{
				$found++;
			}
		}

		return $found;
	}

	function getnegatives( $var )
	{
		$return = array();
		foreach ($var as $entry)
		{
			if( preg_match( "/-/i", $entry ) )
			{
				$return[] = str_replace( "-", "", $entry );
			}
		}

		return $return;
	}

	function hashcache()
	{
        $ssl = ( $_SERVER[ 'SERVER_PORT' ] == "443" ) ? "ssl-" : "" ;

		if( phpversion() >= "4.3.0" )
		{
			$var = sha1( $ssl . $_SERVER[ 'REQUEST_URI' ] );
		}
		else
		{
			$var = md5( $ssl . $_SERVER[ 'REQUEST_URI' ] );
		}

		return $var;
	}

	function stats()
	{
		global $config, $security, $database, $preferences, $user, $ipaddr;
		$stats_month = date( "m" );
		$stats_year = date( "Y" );
		$stats_url = ( isset( $_SERVER[ 'HTTP_REFERER' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_REFERER' ] ) : "" ;
		$stats_agent = ( isset( $_SERVER[ 'HTTP_USER_AGENT' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_USER_AGENT' ] ) : "" ;
		$stats_query = ( isset( $_SERVER[ 'REQUEST_URI' ] ) ) ? $security -> checkvar( $_SERVER[ 'REQUEST_URI' ] ) : "" ;
		$query = $database -> dbquery( "SELECT statcount_id FROM " . DB_PREFIX . "esselbach_ct_statscounter WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

		if( $database -> dbrows( $query ) )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statscounter SET statcount_pageviews = statcount_pageviews + 1 WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
		}
		else
		{
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statscounter (statcount_id, statcount_website, statcount_month, statcount_year, statcount_pageviews, statcount_rssviews) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '1', '0')" );
		}

		if( $preferences[ 'website_stats_referrers' ] )
		{
			$preferences[ 'alt_website_url' ] = str_replace( "www.", "", $preferences[ 'website_url' ] );

			if( ( $stats_url ) and( substr( $stats_url, 0, strlen( $preferences[ 'website_url' ] ) ) != $preferences[ 'website_url' ] ) and( substr( $stats_url, 0, strlen( $preferences[ 'alt_website_url' ] ) ) != $preferences[ 'alt_website_url' ] ) and ( preg_match( "/http:\/\/|https:\/\//i", $stats_url ) ) )
			{
				if ( !preg_match( "/google|msn|yahoo|lycos|live|bing|jeeves|translate_c|q=cache/i", $stats_url ) )
				{
					$query = $database -> dbquery( "SELECT statreferrer_id FROM " . DB_PREFIX . "esselbach_ct_statsreferrers WHERE statreferrer_month = '" . $stats_month . "' AND statreferrer_year = '" . $stats_year . "' AND statreferrer_url = '" . $stats_url . "' AND statreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsreferrers SET statreferrer_count = statreferrer_count + 1 WHERE statreferrer_month = '" . $stats_month . "' AND statreferrer_year = '" . $stats_year . "' AND statreferrer_url = '" . $stats_url . "' AND statreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsreferrers (statreferrer_id, statreferrer_website, statreferrer_month, statreferrer_year, statreferrer_url, statreferrer_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_url . "', '1')" );
					}
				}
			}
		}

		if( $preferences[ 'website_stats_browsers' ] )
		{
			$query = $database -> dbquery( "SELECT statbrowser_id FROM " . DB_PREFIX . "esselbach_ct_statsbrowsers WHERE statbrowser_month = '" . $stats_month . "' AND statbrowser_year = '" . $stats_year . "' AND statbrowser_agent = '" . $stats_agent . "' AND statbrowser_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsbrowsers SET statbrowser_count = statbrowser_count + 1 WHERE statbrowser_month = '" . $stats_month . "' AND statbrowser_year = '" . $stats_year . "' AND statbrowser_agent = '" . $stats_agent . "' AND statbrowser_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsbrowsers (statbrowser_id, statbrowser_website, statbrowser_month, statbrowser_year, statbrowser_agent, statbrowser_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_agent . "', '1')" );
			}
		}

		if( $preferences[ 'website_stats_bots' ] )
		{
			if( preg_match( "/Google|Yahoo|MSNBOT|lycos|Lycos|av\.com|live|jeeves|Twiceler/i", $stats_agent ) )
			{
				if( preg_match( "/Mediapartners/i", $stats_agent ) )
				{
					$stats_bot = 2;
				}
				elseif( preg_match( "/Google/i", $stats_agent ) )
				{
					$stats_bot = 1;
				}
				elseif( preg_match( "/Yahoo/i", $stats_agent ) )
				{
					$stats_bot = 3;
				}
				elseif( preg_match( "/MSNBOT/i", $stats_agent ) )
				{
					$stats_bot = 4;
				}
				elseif( preg_match( "/lycos|Lycos/i", $stats_agent ) )
				{
					$stats_bot = 5;
				}
				elseif( preg_match( "/av\.com/i", $stats_agent ) )
				{
					$stats_bot = 6;
				}
				elseif( preg_match( "/jeeves/i", $stats_agent ) )
				{
					$stats_bot = 7;
				}
				elseif( preg_match( "/live/i", $stats_agent ) )
				{
					$stats_bot = 8;
				}
				elseif( preg_match( "/Twiceler/i", $stats_agent ) )
				{
					$stats_bot = 9;
				}

				if( $stats_query )
				{
					$query = $database -> dbquery( "SELECT statbot_id FROM " . DB_PREFIX . "esselbach_ct_statsbots WHERE statbot_month = '" . $stats_month . "' AND statbot_year = '" . $stats_year . "' AND statbot_bot = '" . $stats_bot . "' AND statbot_query = '" . $stats_query . "' AND statbot_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsbots SET statbot_count = statbot_count + 1 WHERE statbot_month = '" . $stats_month . "' AND statbot_year = '" . $stats_year . "' AND statbot_bot = '" . $stats_bot . "' AND statbot_query = '" . $stats_query . "' AND statbot_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsbots (statbot_id, statbot_website, statbot_month, statbot_year, statbot_bot, statbot_query, statbot_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_bot . "', '" . $stats_query . "', '1')" );
					}
				}
			}
		}

		if( $preferences[ 'website_stats_onlineusers' ] )
		{
			$current_time = time();
			$current_session = time() - intval( $preferences[ 'website_stats_onlinetime' ] );

			if( $user[ 'user_status' ] )
			{
				$online_user = $database -> dbescape( $user[ 'user_name' ] );
				$online_invisible = $database -> dbescape( $user[ 'user_invisible' ] );
				$online_bot = 0;
			}
			else
			{
				$online_user = "";
				$online_invisible = 0;

				if( preg_match( "/Google/i", $stats_agent ) )
				{
					$stats_bot = "Google";
				}
				elseif( preg_match( "/Yahoo/i", $stats_agent ) )
				{
					$stats_bot = "Yahoo";
				}
				elseif( preg_match( "/MSNBOT/i", $stats_agent ) )
				{
					$stats_bot = "MSN";
				}
				elseif( preg_match( "/lycos|Lycos/i", $stats_agent ) )
				{
					$stats_bot = "Lycos";
				}
				elseif( preg_match( "/av\.com/i", $stats_agent ) )
				{
					$stats_bot = "Altavista";
				}
				elseif( preg_match( "/jeeves/i", $stats_agent ) )
				{
					$stats_bot = "Ask Jeeves";
				}
				elseif( preg_match( "/live/i", $stats_agent ) )
				{
					$stats_bot = "Live Search";
				}
				elseif( preg_match( "/Twiceler/i", $stats_agent ) )
				{
					$stats_bot = "Cuil";
				}
				else
				{
					$stats_bot = "";
				}

				if( $stats_bot )
				{
					$online_user = $stats_bot;
					$online_bot = 1;
				}
				else
				{
					$online_bot = 0;
				}
			}

			$this_ip = ( $preferences[ 'website_anon_ip' ] ) ? md5( $_SERVER[ 'HTTP_USER_AGENT' ] ) : $ipaddr ;
			$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_online WHERE online_time < ('" . $current_session . "') OR online_ip ='" . $this_ip . "'" );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_online (online_time, online_website, online_user, online_invisible, online_bot, online_ip) VALUES ('" . $current_time . "', '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $online_user . "', '" . $online_invisible . "', '" . $online_bot . "', '" . $this_ip . "')" );
		}

		if( isset ( $preferences[ 'contacts_stats_referrers' ] ) )
		{
			if( $preferences[ 'contacts_stats_referrers' ] and $stats_url )
			{
				$found = 0;
				$query = $database -> dbquery( "SELECT contact_domain FROM " . DB_PREFIX . "esselbach_ct_contacts" );

				while( list( $contact_domain ) = $database -> dbrow( $query ) )
				{
					if( preg_match( "/" . $contact_domain . "/i", $stats_url ) )
					{
						$found = 1;
					}
				}

				if( $found )
				{
					$query = $database -> dbquery( "SELECT contactreferrer_id FROM " . DB_PREFIX . "esselbach_ct_contactsreferrers WHERE contactreferrer_month = '" . $contacts_month . "' AND contactreferrer_year = '" . $contacts_year . "' AND contactreferrer_url = '" . $stats_url . "' AND contactreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

					if( $database -> dbrows( $query ) )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contactsreferrers SET contactreferrer_count = contactreferrer_count + 1 WHERE contactreferrer_month = '" . $contacts_month . "' AND contactreferrer_year = '" . $contacts_year . "' AND contactreferrer_url = '" . $stats_url . "' AND contactreferrer_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
					}
					else
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_contactsreferrers (contactreferrer_id, contactreferrer_website, contactreferrer_month, contactreferrer_year, contactreferrer_url, contactreferrer_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $contacts_month . "', '" . $contacts_year . "', '" . $stats_url . "', '1')" );
					}
				}
			}
		}
	}

	function encode_array( $var )
	{
		$encoded_array = array();

		if( is_array( $var ) )
		{
			foreach ( $var as $item )
			{
				$encoded_array[] = base64_encode( $item );
			}
			$output = implode( "|", $encoded_array );
		}
		else
		{
			$output = "";
		}
		return $output;
	}

	function decode_array( $var )
	{
		$encoded_array = explode( "|", $var );
		$decoded_array = array();

		foreach ($encoded_array as $item)
		{
			$decoded_array[] = base64_decode( $item );
		}
		return $decoded_array;
	}

	function smtpmail( $var, $var2, $var3, $var4, $var5, $var6, $var7, $var8, $var9 )
	{
		$smtp_connect = fsockopen( $var, $var2 );
		$smtp_banner = fgets( $smtp_connect, 1024 );
		fputs( $smtp_connect, "HELO " . $var . "\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );

		if( substr( $smtp_result, 0, 3 ) != 250 )
		{
			return( $smtp_result );
		}

		if( $var3 )
		{
			fputs( $smtp_connect, "AUTH LOGIN\r\n" );
			fputs( $smtp_connect, base64_encode( $var3 ) . "\r\n" );
			fputs( $smtp_connect, base64_encode( $var4 ) . "\r\n" );
			$smtp_result = fgets( $smtp_connect, 1024 );

			if( substr( $smtp_result, 0, 3 ) != 334 )
			{
				return( $smtp_result );
			}
		}

		fputs( $smtp_connect, "MAIL FROM: <" . $var5 . ">\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );

		if( substr( $smtp_result, 0, 3 ) != 334 )
		{
			return( $smtp_result );
		}

		fputs( $smtp_connect, "RCPT TO: <" . $var6 . ">\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );

		if( substr( $smtp_result, 0, 3 ) != 235 )
		{
			return( $smtp_result );
		}

		fputs( $smtp_connect, "DATA\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );

		if( substr( $smtp_result, 0, 3 ) != 250 )
		{
			return( $smtp_result );
		}

		fputs( $smtp_connect, "Subject: " . $var7 . "\r\n" );
		fputs( $smtp_connect, $var9 . "\r\n\r\n" );
		fputs( $smtp_connect, $var8 . "\r\n" );
		fputs( $smtp_connect, ".\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );

		if( substr( $smtp_result, 0, 3 ) != 250 )
		{
			return( $smtp_result );
		}

		fputs( $smtp_connect, "QUIT\r\n" );
		$smtp_result = fgets( $smtp_connect, 1024 );

		if( substr( $smtp_result, 0, 3 ) != 354 )
		{
			return( $smtp_result );
		}

		fclose( $smtp_connect );
		return( 0 );
	}

	function mailheader( $var, $var2, $var3, $var4 )
	{
		global $preferences;

		$return = ( $preferences[ 'user_registration_emailos' ] == "Windows" ) ? "\r\n" : "\n" ;

		$var = preg_replace( "/\r/", "", $var );
		$var = preg_replace( "/\n/", "", $var );
		$var2 = preg_replace( "/\r/", "", $var2 );
		$var2 = preg_replace( "/\n/", "", $var2 );
		$var3 = preg_replace( "/\r/", "", $var3 );
		$var3 = preg_replace( "/\n/", "", $var3 );
		$var4 = preg_replace( "/\r/", "", $var4 );
		$var4 = preg_replace( "/\n/", "", $var4 );
		$headers = "From: " . $var . " <" . $var2 . ">" . $return;
		$headers .= "To: " . $var3 . " <" . $var4 . ">" . $return;
		$headers .= "Reply-To: " . $var . " <" . $var2 . ">" . $return;
		$headers .= "MIME-Version: 1.0\n";
		$headers .= "Content-type: text/plain; charset=" . $preferences[ 'website_charset' ] . "\n";
		$headers .= "X-Priority: 1\n";
		$headers .= "X-MSMail-Priority: High\n";
		$headers .= "X-Mailer: Esselbach Contentteller CMS";
		return $headers;
	}

	function mailheaderhtml( $var, $var2, $var3, $var4 )
	{
		global $preferences;

		$return = ( $preferences[ 'user_registration_emailos' ] == "Windows" ) ? "\r\n" : "\n" ;

		$var = preg_replace( "/\r/", "", $var );
		$var = preg_replace( "/\n/", "", $var );
		$var2 = preg_replace( "/\r/", "", $var2 );
		$var2 = preg_replace( "/\n/", "", $var2 );
		$var3 = preg_replace( "/\r/", "", $var3 );
		$var3 = preg_replace( "/\n/", "", $var3 );
		$var4 = preg_replace( "/\r/", "", $var4 );
		$var4 = preg_replace( "/\n/", "", $var4 );
		$headers = "From: " . $var . " <" . $var2 . ">" . $return;
		$headers .= "To: " . $var3 . " <" . $var4 . ">" . $return;
		$headers .= "Reply-To: " . $var . " <" . $var2 . ">" . $return;
		$headers .= "MIME-Version: 1.0\n";
		$headers .= "Content-type: text/html; charset=" . $preferences[ 'website_charset' ] . "\n";
		$headers .= "X-Priority: 1\n";
		$headers .= "X-MSMail-Priority: High\n";
		$headers .= "X-Mailer: Esselbach Contentteller CMS";
		return $headers;
	}

	function getpage( $var )
	{
		global $database, $preferences;

		if( $var )
		{
			$page_data = explode( ".", $var );
			$page_query = ( $preferences[ 'website_charset' ] == "UTF-8" ) ? $database -> dbescape( urldecode( $page_data[ 0 ] ) ) : $database -> dbescape( $page_data[ 0 ] ) ;
		}
		else
		{
			$page_query = "";
		}

		return $page_query;
	}

	function getpages( $var, $var2 )
	{
		global $database, $security, $preferences;
		$page_data = explode( ".", $var );
		$page_array = array();

		if( preg_match( "/,/i", $page_data[ 0 ] ) )
		{
			$page_opt = explode( ",", $page_data[ 0 ] );

			$page_array[ ] = ( $preferences[ 'website_charset' ] == "UTF-8" ) ? $database -> dbescape( urldecode( $page_opt[ 0 ] ) ) : $database -> dbescape( $page_opt[ 0 ] ) ;
			$page_array[ ] = $security -> checknum( $page_opt[ 1 ] );
		}
		else
		{
			$page_array[ ] = ( $preferences[ 'website_charset' ] == "UTF-8" ) ? $database -> dbescape( urldecode( $page_data[ 0 ] ) ) : $database -> dbescape( $page_data[ 0 ] ) ;
			$page_array[ ] = $var2;
		}

		return $page_array;
	}

	function getinsert( $var, $var2 )
	{
		global $templates, $system, $preferences, $database, $config, $user;
		$insert[ 'page_charset' ] = htmlspecialchars( $var[ 'website_charset' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'page_rss' ] = "";
		$insert[ 'site_name' ] = $var[ 'website_name' ];
		$insert[ 'site_url' ] = $var[ 'website_url' ];
		$insert[ 'site_logo_path' ] = $var[ 'website_logo_path' ];
		$insert[ 'site_logo_description' ] = $var[ 'website_logo_description' ];
		$insert[ 'site_logo_subtext' ] = $var[ 'website_logo_subtext' ];
		$insert[ 'site_advertisement_header' ] = $var[ 'website_advertisement_header' ];
		$insert[ 'site_advertisement_footer' ] = $var[ 'website_advertisement_footer' ];
		$insert[ 'site_copyright' ] = ( $preferences[ 'website_copyright' ] ) ? "&copy; " . str_replace( "CURRENT_YEAR", date( "Y" ), htmlspecialchars( $preferences[ 'website_copyright' ], ENT_QUOTES, CT_ENCODING ) ). "<br />" : "" ;
		$insert[ 'site_theme' ] = $var[ 'current_theme' ];
		$insert[ 'param_ext' ] = $var[ 'param_ext' ];
		$insert[ 'param_ct' ] = $var[ 'param_ct' ];
		$insert[ 'param_action' ] = $var[ 'param_action' ];
		$insert[ 'param_jaction' ] = $var[ 'param_jaction' ];
		$insert[ 'param_page' ] = $var[ 'param_page' ];
		$insert[ 'param_jpage' ] = $var[ 'param_jpage' ];
		$insert[ 'param_id' ] = $var[ 'param_id' ];
		$insert[ 'param_jid' ] = $var[ 'param_jid' ];

		$powered_by = ( $config[ 'ADMIN_LANGUAGE' ] == "de" ) ? "Diese Website verwendet" : "Powered by" ;

		$affiliate_link = ( $preferences[ 'website_affiliate_id' ] ) ? $affiliate_link = "http://www.shareit.de/affiliate.html?publisherid=200078910&amp;affiliateid=" . $preferences[ 'website_affiliate_id' ] . "&amp;target=" : "" ;
		$insert[ 'site_tasks' ] = ( $preferences[ 'website_managed_with' ] ) ? "<a href=\"" . $affiliate_link . "http://www.contentteller.com\"><img src=\"index.php?ct=core&amp;action=tasks&amp;id=1\" alt=\"Contentteller(R) Business Edition\" /></a>" : "<img src=\"index.php?ct=core&amp;action=tasks&amp;id=1\" alt=\"\" />" ;
		$insert[ 'site_notice' ] = ( $preferences[ 'website_managed_with' ] ) ? $powered_by . " <a href=\"" . $affiliate_link . "http://www.contentteller.com\">Contentteller&reg; Business Edition</a><img src=\"index.php?ct=core&amp;action=tasks\" alt=\"\" />" : "<img src=\"index.php?ct=core&amp;action=tasks\" alt=\"\" />";
		$insert[ 'website_canonical' ] = $preferences[ 'website_canonical' ];

		if( $preferences[ 'user_active' ] )
		{
		    if( $user[ 'user_nocookie' ] )
		    {
		        $insert[ 'site_login' ] = $templates -> exectemplate( $var2[ 'site_login_cookie_html' ], $var2[ 'site_login_cookie_php' ], $insert );
		    }
			elseif( ( $user[ 'user_username' ] ) && ( $user[ 'user_session' ] ) )
			{
				$query = $database -> dbquery( "SELECT count(userprivatemessage_id) FROM " . DB_PREFIX . "esselbach_ct_usersprivatemessages WHERE userprivatemessage_new = '1' AND userprivatemessage_recipient = '" . $database -> dbescape( $user[ 'user_name' ] ) . "' AND userprivatemessage_sent = '0'" );
				list( $pms ) = $database -> dbrow( $query );
				$insert[ 'private_messages' ] = ( $pms ) ? "(" . $pms . ")" : "" ;
				$insert[ 'user_username' ] = $user[ 'user_name' ];
				$insert[ 'site_login' ] = $templates -> exectemplate( $var2[ 'site_login_user_html' ], $var2[ 'site_login_user_php' ], $insert );
			}
			else
			{
				$insert[ 'site_login' ] = $templates -> exectemplate( $var2[ 'site_login_anon_html' ], $var2[ 'site_login_anon_php' ], $insert );
			}
		}
		else
		{
			$insert[ 'site_login' ] = "";
		}

		$input_blocks = ( isset( $preferences[ 'site_blocks_override'] ) ) ? $preferences[ 'site_blocks_override'] : 0 ;
		$blocks = $templates -> prepareblocks( $var2[ 'site_block_html' ], $var2[ 'site_block_php' ], $var2[ 'site_block_alt1_html' ], $var2[ 'site_block_alt1_php' ], $var2[ 'site_block_alt2_html' ], $var2[ 'site_block_alt2_php' ], $input_blocks );

		foreach( $blocks as $block_id => $block_content )
		{
			$insert[ 'site_block_' . $block_id ] = $block_content;
		}

		$query = $database -> dbquery( "SELECT menu_name, menu_link, menu_parentid FROM " . DB_PREFIX . "esselbach_ct_menus WHERE menu_active = '1' AND (menu_website = '0' OR menu_website = '" . $preferences[ 'current_website' ] . "') ORDER BY menu_position, menu_parentmenu, menu_id" );
		$insert[ 'site_menu' ] = $templates -> exectemplate( $var2[ 'site_menu_header_html' ], $var2[ 'site_menu_header_php' ], $insert );

		if ($user[ 'user_status' ] == 2)
		{
			$insert[ 'site_menu' ] .= $templates -> exectemplate( $var2[ 'site_menu_item_admin_html' ], $var2[ 'site_menu_item_admin_php' ], $insert );
		}

		$menu_parentold = 0;

		$site_url = ( $preferences[ 'website_mod_rewrite' ] ) ? $insert[ 'site_url' ] : $insert[ 'site_url' ] . "/index.php" ;

		while( list ( $menu_name, $menu_link, $menu_parentid ) = $database -> dbrow( $query ) )
		{
			if( $menu_parentold == 1 and $menu_parentid == 1)
			{
				$insert[ 'site_menu' ] .= $templates -> exectemplate( $var2[ 'site_menu_item_footer_html' ], $var2[ 'site_menu_item_footer_php' ], $insert );
			}

			if ( $menu_parentid < $menu_parentold )
			{
				$insert[ 'site_menu' ] .= $templates -> exectemplate( $var2[ 'site_menu_sub_item_footer_html' ], $var2[ 'site_menu_sub_item_footer_php' ], $insert );
			}
			if ( $menu_parentid > 1 and $menu_parentold != $menu_parentid )
			{
				$insert[ 'site_menu' ] .= $templates -> exectemplate( $var2[ 'site_menu_sub_item_header_html' ], $var2[ 'site_menu_sub_item_header_php' ], $insert );
			}
			else
			{
				if( $menu_parentold > 1 )
				{
					$insert[ 'site_menu' ] .= $templates -> exectemplate( $var2[ 'site_menu_item_footer_html' ], $var2[ 'site_menu_item_footer_php' ], $insert );
				}
			}
			$insert[ 'menu_name' ] = htmlspecialchars( $menu_name, ENT_COMPAT, CT_ENCODING );

			$insert[ 'menu_link' ] = $system -> rewritelink( str_replace( array( "{\$insert['site_url']}", "{\$insert['param_ct']}", "{\$insert['param_action']}", "{\$insert['param_page']}" ), array( $site_url, $insert[ 'param_ct' ], $insert[ 'param_action' ], $insert[ 'param_page' ] ), htmlspecialchars( $menu_link, ENT_COMPAT, CT_ENCODING ) ) ) ;

			$insert[ 'site_menu' ] .= $templates -> exectemplate( $var2[ 'site_menu_item_header_html' ], $var2[ 'site_menu_item_header_php' ], $insert );
			$menu_parentold = $menu_parentid;
		}

		$insert[ 'site_menu' ] .= $templates -> exectemplate( $var2[ 'site_menu_footer_html' ], $var2[ 'site_menu_footer_php' ], $insert );

		return $insert;
	}

	function rewritelink( $var )
	{
		global $preferences;

		if( $preferences[ 'website_mod_rewrite' ] )
		{
			$var = str_replace( "index.php", "", $var ) ;
		}
		elseif( $preferences[ 'website_forcetype' ] )
		{
			$var = str_replace( "index.php", "contentteller", $var ) ;
		}
		elseif( $preferences[ 'website_basic_rewrite' ] )
		{
			$var = str_replace( "index.php", "?", $var ) ;
		}

		return $var;
	}

	function unhtmlchars( $var )
	{
		$var = strtr( $var, array_flip( get_html_translation_table( HTML_ENTITIES, ENT_QUOTES ) ) );
    	$var = preg_replace( "/&#([0-9]+);/i", "", $var);

		return $var;
	}

	function get_real_url( $var)
	{
		$this_url = $var;
		if( phpversion() >= "5.0.0" )
		{
			$headers = get_headers( $var );
			foreach( $headers as $header )
			{
				if( preg_match( "/Location: http/i", $header ) )
				{
					$url_split = explode( "http://", $header );
					$this_url = "http://" . $url_split[ 1 ];
				}
			}
		}
		return $this_url;
	}

	function getwebsiteurl( $var )
	{
		global $database;
		if( !$var )
		{
			$var = 1;
		}
		$query = $database -> dbquery( "SELECT preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_URL' AND preference_website = '" . $var . "'" );
		list( $url ) = $database -> dbrow( $query );
		return $url;
	}

	function geturltitles( $var )
	{
		global $database;

		preg_match_all("/\[url\](.*)\[\/url\]/Ui", $var, $matches, PREG_SET_ORDER);

		foreach( $matches as $match )
		{
			if( function_exists( "curl_exec" ) )
			{
				$url = curl_init( $match[1] );

				if( preg_match( "/https/i", $match[1] ) )
				{
					curl_setopt( $url, CURLOPT_PORT, 443 );
					curl_setopt( $url, CURLOPT_SSL_VERIFYPEER, false );
				}

				curl_setopt( $url, CURLOPT_RETURNTRANSFER, 1 );
				curl_setopt( $url, CURLOPT_CONNECTTIMEOUT, 5 );
				curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
				$data = curl_exec( $url );
				curl_close( $url );
			}
			else
			{
				$url = fopen( $match[1], "r" );
				$data = fread( $url, 4096 );
				fclose( $url );
			}

			preg_match( "/<title>(.*)<\/title>/i", $data, $title );

			if ( $title[1] != "301 Moved Permanently" )
			{
				$var = str_replace( $match[0], "[url=" . $database -> dbescape( $match[1] ) . "]" . $database -> dbescape( html_entity_decode($title[1]) ) . "[/url]", $var );
			}
		}
		return $var;
	}

	function getvideocodes( $var )
	{
		$var = preg_replace( "/http:\/\/www\.youtube\.com\/watch\?.*v=([a-zA-Z0-9-_]+)/i", "[youtube=\\1]", $var );
		$var = preg_replace( "/http:\/\/www\.dailymotion\.com(?:\/[^\/]+)?\/video\/([a-zA-Z0-9-_]+)_([a-zA-Z0-9-_]+)/i", "[dailymotion=\\1]", $var );
		$var = preg_replace( "/http:\/\/video\.google\.com\/videoplay\?docid=([0-9\-]+)/i", "[googlevideo=\\1]", $var );
		$var = preg_replace( "/http:\/\/(?:www\.)?vimeo\.com\/([0-9]+)/i", "[vimeo=\\1]", $var );
		return $var;
	}

	function gettinyurl( $var )
	{
		if( function_exists( "curl_exec" ) )
		{
			$url = curl_init();
			curl_setopt( $url, CURLOPT_URL, "http://tinyurl.com/api-create.php?url=" . $var );
			curl_setopt( $url, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $url, CURLOPT_CONNECTTIMEOUT, 5 );
			curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
			$data = curl_exec( $url );
			curl_close($url);
		}
		else
		{
			$url = fopen( "http://tinyurl.com/api-create.php?url=" . $var, "r" );
			$data = fread( $url, 4096 );
			fclose( $url );
		}
		return $data;
	}

	function getbitly( $var, $var2, $var3 )
	{
		if( $var2 and $var3 )
		{
			if( function_exists( "curl_exec" ) )
			{
				$url = curl_init();
				curl_setopt( $url, CURLOPT_URL, "http://api.bit.ly/v3/shorten?login=" . $var2 . "&apiKey=" . $var3 . "&uri=" . urlencode( $var ) . "&format=txt" );
				curl_setopt( $url, CURLOPT_RETURNTRANSFER, 1 );
				curl_setopt( $url, CURLOPT_CONNECTTIMEOUT, 5 );
				curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
				$data = curl_exec( $url );
				curl_close($url);
			}
			else
			{
				$url = fopen( "http://api.bit.ly/v3/shorten?login=" . $var2 . "&apiKey=" . $var3 . "&uri=" . urlencode( $var ) . "&format=txt", "r" );
				$data = fread( $url, 4096 );
				fclose( $url );
			}
			return $data;
		}
	}

	function doplurk( $var, $var2, $var3 )
	{
		if( function_exists( "curl_exec" ) )
		{
			$var = str_replace( "&", "&amp;", $var );
			$url = curl_init();
			curl_setopt( $url, CURLOPT_URL, "http://www.plurk.com/Users/login" );
			curl_setopt( $url, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $url, CURLOPT_COOKIEJAR, "cookie.txt" );
			curl_setopt( $url, CURLOPT_COOKIEFILE, "cookie.txt" );
			curl_setopt( $url, CURLOPT_POSTFIELDS, "nick_name=" . $var2 . "&password=" . $var3 );
			curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
			curl_exec( $url );

			curl_setopt( $url, CURLOPT_URL, "http://www.plurk.com/" . $var2 );
			curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
			$profile = curl_exec( $url );

			preg_match( "/var GLOBAL = \{.*\"uid\": ([\d]+),.*\}/imU", $profile, $matches );
			$uid = $matches[1];
			$postarray = explode ("+", gmdate("c") );

			curl_setopt( $url, CURLOPT_URL, "http://www.plurk.com/TimeLine/addPlurk" );
			curl_setopt( $url, CURLOPT_POSTFIELDS, "posted=" . urlencode( $postarray[0] ) . "&qualifier=" . urlencode( "says" ) . "&content=" . urlencode( $var ) . "&lang=" . urlencode( "en" ) . "&uid=" . $uid . "&no_comments=0" );
			curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
			curl_exec( $url );
			curl_close( $url );
		}
	}

	function dorecaptcha( $var, $var2, $var3, $var4 )
	{
		$error = 1;
		if( function_exists( "curl_exec" ) )
		{
			$url = curl_init();
			curl_setopt( $url, CURLOPT_URL, "http://api-verify.recaptcha.net/verify" );
			curl_setopt( $url, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $url, CURLOPT_POSTFIELDS, "privatekey=" . $var . "&remoteip=" . $var2 . "&challenge=" . $var3 . "&response=" . $var4 );
			curl_setopt( $url, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
			$recaptcha = curl_exec( $url );

			if ( preg_match( "/true/i", $recaptcha ) )
			{
				$error = 0;
			}

			curl_close( $url );
		}
		return $error;
	}

	function getpermissions( $var, $var2 )
	{
		if ( substr( sprintf( "%o", fileperms( $var ) ), -4 ) == $var2 )
		{
			return 1;
		}
		else
		{
			return 0; // Computer says No
		}
	}

	function datastoreput( $var, $var2 )
	{
		global $config, $database;
		$expire = mktime() + 600;
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_datastore (datastore_id, datastore_query, datastore_website, datastore_data, datastore_expire) VALUES (NULL, '" . $database -> dbescape( $var ) . "', '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $database -> dbescape( $var2 ) . "', '" . $expire . "')" );
	}

	function datastoreget( $var )
	{
		global $config, $database;
		$current = mktime();
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_datastore WHERE datastore_query = '" . $database -> dbescape( $var ) . "' AND datastore_website = '" . intval( $config[ 'WEBSITE' ] ) . "' AND datastore_expire < '" . $current . "'" );
		$query = $database -> dbquery( "SELECT datastore_data FROM " . DB_PREFIX . "esselbach_ct_datastore WHERE datastore_query = '" . $database -> dbescape( $var ) . "' AND datastore_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
		list( $data ) = $database -> dbrow( $query );
		return $data;
	}

	function adminhashput()
	{
		global $database, $login_loginname;
		$var = md5( $login_loginname . microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) ) . md5( microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) . $login_loginname );

		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_adminsessions SET session_hash = '" . $database -> dbescape( $var ) . "' WHERE session_adminuser = '" . $database -> dbescape( $login_loginname ) . "'");

		return $var;
	}

	function adminhashget()
	{
		global $database, $login_loginname;

		$query = $database -> dbquery( "SELECT session_hash FROM " . DB_PREFIX . "esselbach_ct_adminsessions WHERE session_adminuser = '" . $database -> dbescape( $login_loginname ) . "'");
		if ($database -> dbrows( $query ))
		{
			list( $var ) = $database -> dbrow( $query );
		}
		else
		{
			$var = md5( $login_loginname . microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) ) . md5( microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) . $login_loginname );
		}

		return $var;
	}

	function dorand()
	{
		$var = md5( microtime() . uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) ) . md5( uniqid( mt_rand(), true ) . implode( '', fstat( fopen( __FILE__, 'r' ) ) ) . microtime() );
		return $var;
	}

	function doseo( $var )
	{
		global $preferences;

		if( $preferences[ 'website_charset' ] != "UTF-8" )
		{
			$var = strtolower( $var );
			$var = str_replace( "&amp;", "&", htmlentities( $var, ENT_QUOTES, CT_ENCODING ) );
			$var = str_replace( array( "&auml;", "&Auml;", "&aacute;", "&Aacute;", "&agrave;", "&Agrave;", "&atilde;", "&Atilde;", "&acirc;", "&Acirc;", "&ccedil;", "&Ccedil;", "&euml;", "&Euml;", "&eacute;", "&Eacute;", "&egrave;", "&Egrave;", "&ecirc;", "&Ecirc;", "&iuml;", "&Iuml;", "&iacute;", "&Iacute;", "&igrave;", "&Igrave;", "&icirc;", "&Icirc;", "&ntilde;", "&Ntilde", "&ouml;", "&Ouml;", "&oacute;", "&ograve;", "&Ograve;", "&otilde;", "&Otilde;", "&ocirc;", "&Ocirc;", "&szlig;", "&uuml;", "&Uuml;", "&uacute;", "&Uacute;", "&ugrave;", "&Ugrave;", "&ucirc;", "&Ucirc;" ), array( "ae", "ae", "a", "a", "a", "a", "a", "a", "a", "a", "c", "c", "e", "e", "e", "e", "e", "e", "e", "e", "i", "i", "i", "i", "i", "i", "i", "i", "n", "n", "oe", "oe", "o", "o", "o", "o", "o", "o", "o", "ss", "ue", "ue", "u", "u", "u", "u", "u", "u" ), $var );
		}
		else
		{
			mb_internal_encoding( "UTF-8" );
			$var = mb_strtolower( $var );
		}
		$var = str_replace( array( ", ", "'", '"', " . ", "!", "$", "^", "*", ";", "%", "?", "( ", " )", "~", "@", "#", "[ ", " ]", "<", ">", "\\", "/", ":", "&", " = ", "+", "�", "�", "," ), "", $var);

		$var_new = array();
		$var_array = explode( "_", str_replace( array( "-", " ", "." ), "_", $var ) );
		foreach( $var_array as $var_entry )
		{
			if( $var_entry )
			{
				$var_new[] = $var_entry;
			}
		}
		$var = implode( "_", $var_new );

		if( $preferences[ 'website_charset' ] != "UTF-8" )
		{
			$var = preg_replace( "/(&(amp|gt|lt|quot|mdash);|[^a-zA-Z0-9_-])+/i", "", $var );
		}
		return $var;
	}

	function seorand()
	{
		global $preferences;

		if( $preferences[ 'website_seo_hyphens' ] )
		{
			$var = "-" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
		}
		else
		{
			$var = "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
		}

		return $var;
	}

	function parsedata( $var )
	{
		if( function_exists( "curl_exec" ) )
		{
			$this_newsstory = curl_init( $var );

			if( preg_match( "/https/i", $var ) )
			{
				curl_setopt( $this_newsstory, CURLOPT_PORT, 443 );
				curl_setopt( $this_newsstory, CURLOPT_SSL_VERIFYPEER, false );
			}

			curl_setopt( $this_newsstory, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $this_newsstory, CURLOPT_CONNECTTIMEOUT, 5 );
			curl_setopt( $this_newsstory, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
			$data = curl_exec( $this_newsstory );
			curl_close( $this_newsstory );
		}
		else
		{
			$this_newsstory = @fopen( $var, "r" );
			$data = "";
			while( $output = fread( $this_newsstory, 4096 ))
			{
				$data .= $output;
			}
			fclose( $this_newsstory );
		}

		$title_array = array();
		$title2_array = array();
		$description_array = array();
		$description2_array = array();
		$description3_array = array();
		$description4_array = array();
		$description5_array = array();
		$description6_array = array();
		$description7_array = array();
		$video_id = array();

		preg_match( "/<title>(.*)<\/title>/i", substr( preg_replace( "/(\n|\r|\t|&(amp|gt|lt|quot|mdash);)/", "", $data), 0, 1000 ), $title_array );
		preg_match( "/document.title = 'YouTube - (.*)'/smUi", $data, $title2_array );
		preg_match( "/id=\"video_description\">(.*)<\/div>/smUi", $data, $description_array );
		preg_match( "|<meta[^>]*description[^>]*content=\"([^>]+)\"[^>]*>|Ui", $data, $description2_array );
		preg_match( "/<div class=\"story-content\".*>(.*)<\/div>/smUi", $data, $description3_array );
		preg_match( "/<div class=\"story_content\">(.*)<\/div>/smUi", $data, $description4_array );
		preg_match( "/<div id=\"news_item\">(.*)<a name=\"comments\">/smUi", $data, $description5_array );
		preg_match( "/<div class=\"entry\">(.*)<p class=\"tags\">/smUi", $data, $description6_array );
		preg_match( "/<div class=\"postbody\">(.*)<div class=\"postmeta\">/smUi", $data, $description7_array );

		if( count( $title_array ) > 0 )
		{
			$var2 = trim( strip_tags( $title_array[ 1 ] ) );
		}
		else
		{
			$var2 = $var;
		}

		if( count( $title2_array ) > 0 )
		{
			preg_match( "/\'VIDEO_ID\': \'(.*)\'/i", $data, $video_id );
			$var2 = $title2_array[ 1 ];
			$var3 = "[youtube=" . trim( $video_id[ 1 ] ) . "]\n\n" . trim( strip_tags( str_replace( "<br />", "\n", $description2_array[ 1 ] ) ) );
			$var = "";
		}
		elseif( count( $description_array ) > 0 )
		{
			preg_match( "/meta property=\"og:url\" content=\"http:\/\/www.dailymotion.com\/video\/(.*)\"/i", $data, $video_id );
			$video_id = explode( "_", $video_id[ 1 ] );
			$var3 = "[dailymotion=" . trim( $video_id[ 0 ] ) . "]\n\n" . trim( strip_tags( str_replace( "<br />", "\n", $description6_array[ 1 ] ) ) );
			$var = "";
		}
		elseif( count( $description2_array ) > 0 )
		{
			$var3 = trim( strip_tags( $description2_array[ 1 ] ) );
		}
		elseif( count( $description3_array ) > 0 )
		{
			$var3 = trim( strip_tags( str_replace( "<br />", "\n", $description3_array[ 1 ] ) ) );
		}
		elseif( count( $description4_array ) > 0 )
		{
			$var3 = trim( strip_tags( str_replace( "<br />", "\n", $description4_array[ 1 ] ) ) );
		}
		elseif( count( $description5_array ) > 0 )
		{
			$var3 = trim( strip_tags( str_replace( "<br />", "\n", $description5_array[ 1 ] ) ) );
		}
		elseif( count( $description6_array ) > 0 )
		{
			$var3 = trim( strip_tags( str_replace( array( "<br />", "</p><p>"), array( "\n", "\n\n" ), $description7_array[ 1 ] ) ) );
		}
		elseif( count( $description7_array ) > 0 )
		{
			$var3 = trim( strip_tags( str_replace( "<br />", "\n", $description8_array[ 1 ] ) ) );
		}
		else
		{
			$var3 = $var2;
		}

		if( preg_match( "/http:\/\/(?:www\.)?vimeo\.com\/([0-9]+)/i", $var, $video_id ) )
		{
			$var3 = "[vimeo=" . trim( $video_id[ 1 ] ) . "]\n\n" . trim( strip_tags( str_replace( "<br />", "\n", $description2_array[ 1 ] ) ) );
			$var = "";
		}

		return array( $var, $var2, $var3 );
	}

	function init( $var )
	{
		global $preferences;

		$var = ( $var ) ? "../" : "" ;

		if( $preferences[ 'website_seo' ] )
		{
			if( $preferences[ 'website_seo_method' ] == "Path Info" or $preferences[ 'website_basic_rewrite' ] or $preferences[ 'website_mod_rewrite' ] or $preferences[ 'website_forcetype' ] )
			{
				$preferences[ 'param_ct' ] = "/";
			}
			else
			{
				$preferences[ 'param_ct' ] = "?/";
			}
			if ( $preferences[ 'website_module_separator'] )
			{
				$preferences[ 'param_action' ] = "/";
				$preferences[ 'param_jaction' ] = "/";
			}
			else
			{
				$preferences[ 'param_action' ] = "_";
				$preferences[ 'param_jaction' ] = "_";
			}
			$preferences[ 'param_page' ] = "/";
			$preferences[ 'param_id' ] = "/";
			$preferences[ 'param_jpage' ] = "/";
			$preferences[ 'param_jid' ] = "/";
		}
		else
		{
			$preferences[ 'param_ct' ] = "?ct=";
			$preferences[ 'param_action' ] = "&amp;action=";
			$preferences[ 'param_page' ] = "&amp;page=";
			$preferences[ 'param_id' ] = "&amp;id=";
			$preferences[ 'param_jaction' ] = "&action=";
			$preferences[ 'param_jpage' ] = "&page=";
			$preferences[ 'param_jid' ] = "&id=";
		}

		if( $preferences[ 'website_forcetype' ] )
		{
			$preferences[ 'param_ext' ] = "";
		}
		else
		{
			$preferences[ 'param_ext' ] = ".php";
		}

		if( $preferences[ 'website_uwrapper_product' ] == "vBulletin 3.8" )
		{
			include( $var . "classes/class_uwrapper_vb38.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "vBulletin 4" )
		{
			include( $var . "classes/class_uwrapper_vb4.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "vBulletin 5" )
		{
			include( $var . "classes/class_uwrapper_vb5.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "XenForo" )
		{
			include( $var . "classes/class_uwrapper_xf1.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "UBB.threads 7" )
		{
			include( $var . "classes/class_uwrapper_ubbt7.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "IP.Board 3" )
		{
			include( $var . "classes/class_uwrapper_ipb3.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "phpBB 3" )
		{
			include( $var . "classes/class_uwrapper_phpbb3.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "SMF 1.1" )
		{
			include( $var . "classes/class_uwrapper_smf11.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "SMF 2" )
		{
			include( $var . "classes/class_uwrapper_smf2.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "WBB 3" )
		{
			include( $var . "classes/class_uwrapper_wbb3.php" );
		}
		elseif( $preferences[ 'website_uwrapper_product' ] == "WBB 4" )
		{
			include( $var . "classes/class_uwrapper_wbb4.php" );
		}
		elseif( preg_match( "/3rd_/i", $preferences[ 'website_uwrapper_product' ] ) )
		{
			$cfile = str_replace( array( "class_uwrapper_3rd_", ".php" ), "", $preferences[ 'website_uwrapper_product' ] );
			include( $var . "classes/class_uwrapper_3rd_" . $cfile . ".php" );
		}
		else
		{
			include( $var . "classes/class_uwrapper_ct.php" );
		}
	}
}
?>